
//#include <sndfile.h>
#include "filtre.h"

/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
// NE PAS MODIFIER JUSQU'A NOUVEL ORDRE!!!!
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "./qcustomplot.h"
#include <QDebug>
#include <QDesktopWidget>
#include <QScreen>
#include <QMessageBox>
#include <QMetaEnum>
#include <stdio.h>
////////////////////////////////////////////////////////////////////////

MainWindow::MainWindow(int nbAxes, QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    setGeometry(100, 100, 542, 390);
    //Filtrage(ui->customPlot);
    setWindowTitle("QCustomPlot: "+demoName);
    statusBar()->clearMessage();
    currentDemoIndex = 20;
    ui->customPlot->replot();

    ui->customPlot->plotLayout()->clear();  // clear default axis rect so we can start from scratch
    for (int i=0; i< nbAxes; i++)
    {
        QCPAxisRect *Axe = new QCPAxisRect(ui->customPlot);
        Axe->axis(QCPAxis::atLeft)->setVisible(true);
        Axe->axis(QCPAxis::atLeft)->setTickLabels(true);
        Axe->axis(QCPAxis::atLeft)->setRange(0,0.1);
        Axe->axis(QCPAxis::atBottom)->setVisible(true);
        Axe->axis(QCPAxis::atBottom)->setTickLabels(true);
        Axe->axis(QCPAxis::atBottom)->setRange(0,0.1);
        ui->customPlot->plotLayout()->addElement(i, 0, Axe); // insert axis rect in une nouvelle row
    }

    QCPItemTracer *phaseTracer = new QCPItemTracer(ui->customPlot);
    ui->customPlot->addItem(phaseTracer);
    itemDemoPhaseTracer = phaseTracer ;
    itemDemoPhaseTracer->setStyle(QCPItemTracer::tsCircle);
    itemDemoPhaseTracer->setSize(7);

    connect(ui->customPlot, SIGNAL(mouseMove(QMouseEvent*)), this,SLOT(showPointToolTip(QMouseEvent*)));
}


////////////////////////////////////////////////////////////////////////
MainWindow::~MainWindow()
{    delete ui;}
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
// VOUS POUVEZ MODIFIER A PARTIR D'ICI!!!!
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

//ajouter ici toutes les fonctions que vous devez créer

/////////////////////////////////////////////////////////////////
void MainWindow::showPointToolTip(QMouseEvent *event)
    {
    QCustomPlot* const pQCPlot = ui->customPlot ;

    int i = 0;
    while ( i < pQCPlot->graphCount() )
    {
        double distance = pQCPlot->graph(i)->selectTest(QPointF(event->pos().x(),event->pos().y()),true);
        if  ( (distance < 15 ) && distance >= 0 )
        {
            double x = (pQCPlot->graph(i)->keyAxis()->pixelToCoord(event->pos().x()));
            itemDemoPhaseTracer->setGraph(pQCPlot->graph(i));
            itemDemoPhaseTracer->setGraphKey(x);
            itemDemoPhaseTracer->setBrush(QBrush((pQCPlot->graph(i)->pen().color())));
            itemDemoPhaseTracer->setClipAxisRect(pQCPlot->graph(i)->keyAxis()->axisRect());
            setToolTip(QString("x=%1,y=%2").arg(itemDemoPhaseTracer->position->key()).arg(itemDemoPhaseTracer->position->value()));
            pQCPlot->replot();
        }
        i++;
    }

}

void MainWindow::plot(DataATracer data)
{
    styleTrace param={Qt::green,QCPGraph::lsImpulse,QCPScatterStyle::ssCircle};
    this->plot(data,param);
}
void MainWindow::plot(int numAxe, DataATracer data)
{
    styleTrace param={Qt::green,QCPGraph::lsImpulse,QCPScatterStyle::ssCircle};
    this->plot(numAxe, data,param);
}
void MainWindow::plot(DataATracer data, styleTrace paramGraphe)
{
    this->plot(0,data.pX,data.pY,data.nbData,paramGraphe);
}

void MainWindow::plot(int numAxe, DataATracer data, styleTrace paramGraphe)
{
    this->plot(numAxe,data.pX,data.pY,data.nbData,paramGraphe);
}

void MainWindow::plot(int numAxes, double * ptr_x, double* ptr_y, uint nbPts, styleTrace paramGraphe)
{
    QCustomPlot* const pQCPlot = ui->customPlot ;
    if ( numAxes > pQCPlot->plotLayout()->rowCount()-1)
    {
         fputs("plot : le graphe indiqué n'existe pas", stderr);
        return;

    }

    // Copie les tableaux de valeurs dans des Qvector
    QVector<double> x(nbPts), y(nbPts);
    std::vector<double> auxVector;

    auxVector.assign(ptr_x, ptr_x + nbPts);
    x =  QVector<double>::fromStdVector(auxVector);
    auxVector.assign(ptr_y, ptr_y + nbPts);
    y =  QVector<double>::fromStdVector(auxVector);

    // create graph and assign data to it:
    QCPGraph *graphe = pQCPlot->addGraph(pQCPlot->axisRect(numAxes)->axis(QCPAxis::atBottom),pQCPlot->axisRect(numAxes)->axis(QCPAxis::atLeft));
    graphe->setData(x, y);
    graphe->setPen(QPen(paramGraphe.couleur));
    graphe->setLineStyle(paramGraphe.style_ligne);
    graphe->setScatterStyle(QCPScatterStyle(paramGraphe.style_point, 5));
    // let the ranges scale themselves so graph fits perfectly in the visible area:
    if (pQCPlot->axisRect(numAxes)->graphs().size() == 1)
        graphe->rescaleAxes();
    else
        graphe->rescaleAxes(true);

    // zoom out a bit:
    pQCPlot->axisRect(numAxes)->axis(QCPAxis::atBottom)->scaleRange(1.1, pQCPlot->axisRect(numAxes)->axis(QCPAxis::atBottom)->range().center());
    pQCPlot->axisRect(numAxes)->axis(QCPAxis::atLeft)->scaleRange(1.1, pQCPlot->axisRect(numAxes)->axis(QCPAxis::atLeft)->range().center());

    // set axes ranges, so we see all data:
   //QCPlot->xAxis->setRange(x[0], x[nbPts-1]);

    // Un peu d'esthétique
    pQCPlot->setBackground(QBrush (QColor(216,216,216)));
    QPen grille;
    grille.setStyle(Qt::DashLine);
    grille.setColor(QColor (64,64,64,128));
    pQCPlot->axisRect(numAxes)->axis(QCPAxis::atBottom)->grid()->setPen(grille);
    pQCPlot->axisRect(numAxes)->axis(QCPAxis::atBottom)->grid()->setZeroLinePen(QPen (QColor(96,96,96)));
    pQCPlot->axisRect(numAxes)->axis(QCPAxis::atLeft)->grid()->setPen(grille);
    pQCPlot->axisRect(numAxes)->axis(QCPAxis::atLeft)->grid()->setZeroLinePen(QPen (QColor(96,96,96)));

    // Allow user to drag axis ranges with mouse, zoom with mouse wheel and select graphs by clicking:
    pQCPlot->setInteractions(QCP::iRangeDrag | QCP::iRangeZoom ); //| QCP::iSelectPlottables);

}

/*!
 * \brief MainWindow::setLegend affiche des légendes sur les axes du tracé numAxes
 * \param numAxes numéro du graphique en partant de 0
 * \param x chaîne de caractères pour les abscisses
 * \param y chaîne de caractères pour les ordonnées
 */
void MainWindow::setLegend(int numAxes, const QString &x, const QString &y)
{    
    QCustomPlot* const pQCPlot = ui->customPlot ;
    if ( numAxes > pQCPlot->plotLayout()->rowCount()-1)
    {
         fputs("SetLegend : le graphe indiqué n'existe pas", stderr);
        return;
    }
            // give the axes some labels:
    pQCPlot->axisRect(numAxes)->axis(QCPAxis::atBottom)->setLabel(x);
    pQCPlot->axisRect(numAxes)->axis(QCPAxis::atLeft)->setLabel(y);

}
void MainWindow::setLegend(const QString &x, const QString &y)
{
    setLegend(0,x,y);
}

/*!
 * \brief MainWindow::setLogScale choisit un axe des abscisses linéaire ou logarithmique
 * \param numAxes numéro du graphique en partant de 0
 * \param log à false pour une échelle linéaire
 */
void MainWindow::setLogScale(int numAxes, bool log)
{
    QCustomPlot* const pQCPlot = ui->customPlot ;
    if ( numAxes > pQCPlot->plotLayout()->rowCount()-1)
    {
         fputs("SetLogScale : le graphe indiqué n'existe pas", stderr);
        return;

    }
    if (log)
    {
        pQCPlot->axisRect(numAxes)->axis(QCPAxis::atBottom)->setScaleType(QCPAxis::stLogarithmic);
        pQCPlot->axisRect(numAxes)->axis(QCPAxis::atBottom)->setSubTickCount(10);
    }
    else
    {
        pQCPlot->axisRect(numAxes)->axis(QCPAxis::atBottom)->setScaleType(QCPAxis::stLinear);
        pQCPlot->axisRect(numAxes)->axis(QCPAxis::atBottom)->setSubTickCount(10);
    }
}

void MainWindow::setLogScale(bool log)
{
    QCustomPlot* const pQCPlot = ui->customPlot ;

    for (int i = 0; i < pQCPlot->plotLayout()->rowCount(); i++)
        setLogScale(i,log);
}

/*!
 * \brief MainWindow::setGrid affiche la grille
 * \param numAxes numéro du graphique en partant de 0
 * \param grid à true affiche la grille
 */
void MainWindow::setGrid(int numAxes, bool grid)
{
    QCustomPlot* const pQCPlot = ui->customPlot ;
    if ( numAxes > pQCPlot->plotLayout()->rowCount()-1)
    {
         fputs("SetGrid : le graphe indiqué n'existe pas", stderr);
        return;

    }
     pQCPlot->axisRect(numAxes)->axis(QCPAxis::atBottom)->grid()->setVisible(grid);
     pQCPlot->axisRect(numAxes)->axis(QCPAxis::atLeft)->grid()->setVisible(grid);
}

void MainWindow::setGrid(bool grid)
{
    QCustomPlot* const pQCPlot = ui->customPlot ;

    for (int i = 0; i < pQCPlot->plotLayout()->rowCount(); i++)
        setGrid(i,grid);
}

/*!
 * \brief MainWindow::setInterpolation autorise l'interpolation entre les points du graphe
 * \param interp à false : pas d'interpolation
 */
void MainWindow::setInterpolation(bool interp)
{
    itemDemoPhaseTracer->setInterpolating(interp);
}
/*!
 * \brief MainWindow::setNomGraphe donne un nom au dernier graphe tracé
 * \param Nom la chaine de caractère où est stocké le nom
 */
void MainWindow::setNomGraphe(const QString &Nom)
{
    QCustomPlot* const pQCPlot = ui->customPlot ;

    pQCPlot->graph()->setName(Nom);
}

/*  impossible d'utiliser pQCPlot->legend car détruit lors de la création des axes !
  void MainWindow::afficheNoms()
{
    QCustomPlot* const pQCPlot = ui->customPlot ;

    pQCPlot->legend->setVisible(true);
}
*/
///////////////////////////////////////////////////////////////////////








































