//#include <QAudioDeviceInfo>
//#include <QAudioOutput>
#include "/usr/include/x86_64-linux-gnu/qt5/QtMultimedia/QAudioDeviceInfo"
#include "/usr/include/x86_64-linux-gnu/qt5/QtMultimedia/QAudioOutput"





#include <QDebug>
#include <QVBoxLayout>
#include <cmath>
#include <qendian.h>

#include "util.h"

#define SUSPEND_LABEL   "Arrêt playback"
#define START_LABEL   "Démarre playback"
#define RESUME_LABEL    "Poursuite playback"
#define VOLUME_LABEL    "Volume:"

void calcTransfBilin(double A,double B,double C,double D,double E,double F,double Tech, double *coef_b,double *coef_a)
{
    double den = 4*A + C*pow(Tech,2) + 2*B*Tech ;

    coef_b[0] = (4*D + F*pow(Tech,2) + 2*E*Tech) / den ;
    coef_b[1] = (2*F*pow(Tech,2) - 8*D ) / den ;
    coef_b[2] = (-2*E*Tech + 4*D +  F*pow(Tech,2)) /den ;

    coef_a[0] = 1 ;
    coef_a[1] = (2*C*pow(Tech,2) - 8*A ) / den ;
    coef_a[2] = (-2*B*Tech + 4*A +  C*pow(Tech,2)) /den ;

}

/*
AudioPlayer::AudioPlayer(double *pSignal, unsigned int nbEch , unsigned int Fech)
    :   m_suspendResumeButton(0)
    ,   m_device(QAudioDeviceInfo::defaultOutputDevice())
    ,   m_pAudioOutputStreamer(0)
{
    initializeWindow();
    initializeAudio(pSignal, nbEch, Fech);
}

void AudioPlayer::initializeWindow()
{
    QScopedPointer<QWidget> window(new QWidget);
    QScopedPointer<QVBoxLayout> layout(new QVBoxLayout);

    m_suspendResumeButton = new QPushButton(this);
    m_suspendResumeButton->setText(tr(SUSPEND_LABEL));
    connect(m_suspendResumeButton, SIGNAL(clicked()), SLOT(toggleSuspendResume()));
    layout->addWidget(m_suspendResumeButton);

    QHBoxLayout *volumeBox = new QHBoxLayout;
    m_volumeLabel = new QLabel;
    m_volumeLabel->setText(tr(VOLUME_LABEL));
    m_volumeSlider = new QSlider(Qt::Horizontal);
    m_volumeSlider->setMinimum(0);
    m_volumeSlider->setMaximum(100);
    m_volumeSlider->setSingleStep(10);
    connect(m_volumeSlider, SIGNAL(valueChanged(int)), this, SLOT(volumeChanged(int)));
    volumeBox->addWidget(m_volumeLabel);
    volumeBox->addWidget(m_volumeSlider);
    layout->addLayout(volumeBox);

    window->setLayout(layout.data());
    layout.take(); // ownership transferred

    setCentralWidget(window.data());
    QWidget *const windowPtr = window.take(); // ownership transferred
    windowPtr->show();
}

void AudioPlayer::initializeAudio(double* pSignal, unsigned int nbEch, unsigned int Fech)
{
    m_pAudioOutputStreamer = new AudioOutputStreamer(pSignal, nbEch, Fech);
    m_pAudioOutputStreamer->start();

    m_volumeSlider->setValue(int(m_pAudioOutputStreamer->_audio->volume()*100.0));

}

AudioPlayer::~AudioPlayer()
{

}


void AudioPlayer::volumeChanged(int value)
{
    if (m_pAudioOutputStreamer->_audio)
        m_pAudioOutputStreamer->_audio->setVolume(qreal(value/100.0f));
}

void AudioPlayer::handleStateChanged(QAudio::State newState)
{
    switch (newState) {
        case QAudio::IdleState:
            m_suspendResumeButton->setText(tr(START_LABEL));

            break;

        case QAudio::StoppedState:
            printf("flux audio stoppé\n");
            break;

        default:
            // ... other cases as appropriate
            break;
    }
}


void AudioPlayer::toggleSuspendResume()
{
    if (m_pAudioOutputStreamer->_audio->state() == QAudio::SuspendedState) {
        m_pAudioOutputStreamer->_audio->resume();
        m_suspendResumeButton->setText(tr(SUSPEND_LABEL));
    } else if (m_pAudioOutputStreamer->_audio->state() == QAudio::ActiveState) {
        m_pAudioOutputStreamer->_audio->suspend();
        m_suspendResumeButton->setText(tr(RESUME_LABEL));
    } else if (m_pAudioOutputStreamer->_audio->state() == QAudio::StoppedState) {
        m_pAudioOutputStreamer->_audio->resume();
        m_suspendResumeButton->setText(tr(SUSPEND_LABEL));
    } else if (m_pAudioOutputStreamer->_audio->state() == QAudio::IdleState) {
        m_pAudioOutputStreamer->_audio->resume();
        m_suspendResumeButton->setText(tr(SUSPEND_LABEL));
    }
}


AudioOutputStreamer::AudioOutputStreamer(double* pSignal, unsigned int nbEch, unsigned int Fech)
{
    _samplingRate = Fech;

    QAudioFormat format;
    // set up the format you want, eg.
    format.setSampleRate(_samplingRate);
    format.setChannelCount(1);
    format.setSampleSize(16);
    format.setCodec("audio/pcm");
    format.setByteOrder(QAudioFormat::LittleEndian);
    format.setSampleType(QAudioFormat::SignedInt);

    QAudioDeviceInfo info = QAudioDeviceInfo::defaultOutputDevice();
    if (!info.isFormatSupported(format)) {
        qWarning()<<"default format not supported try to use nearest";
        format = info.nearestFormat(format);
    }

    _audio = new QAudioOutput(format, this);
    _audio->setNotifyInterval(20);
    _audio->setBufferSize(32768);//in bytes

    _IDWrittenSample = 0;
    _sizeBuffer = 0;

    m_pSignal = pSignal;
    m_nbEch = nbEch;

    _audio->setVolume(0.5);
}

AudioOutputStreamer::~AudioOutputStreamer()
{
}

void AudioOutputStreamer::start()
{
    QObject::connect(_audio, SIGNAL(notify()), this, SLOT(slot_writeMoreData()));


    _pAudioIOBuffer = _audio->start();
    _sizeBuffer = 65536; //periodSize;
    _buffer = (qint8*) calloc(_sizeBuffer, sizeof(qint8));

    _onetime = true;
    slot_writeMoreData();

}


void AudioOutputStreamer::slot_writeMoreData()
{
    unsigned int nbBytes = _audio->bytesFree();

    if (nbBytes>0)
    {
        if (!_onetime)
        {
            if (_IDWrittenSample >= m_nbWrittenBytes - nbBytes)
                _IDWrittenSample = _IDWrittenSample - (m_nbWrittenBytes - nbBytes);
            else
                _IDWrittenSample = m_nbEch - (m_nbWrittenBytes-nbBytes - _IDWrittenSample);
        }
        else _onetime=false;

        if (_IDWrittenSample<=m_nbEch)

        /* if (_sizeBuffer<(nbBytes/2))
        {
            delete[] _buffer;
            _sizeBuffer = nbBytes/2;
            _buffer = (qint16*) calloc(_sizeBuffer, sizeof(qint16));
        }

        {
            qint8 value = 0;
            for (unsigned int IDSample=0; IDSample<nbBytes; IDSample++) {
                if (abs(m_pSignal[_IDWrittenSample]) < 1)
                    value = (qint8) (m_pSignal[_IDWrittenSample]*128);
                else
                {
                    if (m_pSignal[_IDWrittenSample]<0)
                        value = -128;
                    else
                        value = 127;
                }
                _buffer[IDSample] = value;
                if (_IDWrittenSample == m_nbEch-1)
                {
                    _IDWrittenSample = 0;
                    //QObject::disconnect(_audio, SIGNAL(notify()), this, SLOT(slot_writeMoreData()));
                    //_audio->stop();
                }
                else
                    _IDWrittenSample++;
            }

            m_nbWrittenBytes = _pAudioIOBuffer->write((const char*) _buffer, nbBytes);
            if (nbBytes!=m_nbWrittenBytes)
                qWarning()<<"pb egalite"<<_IDWrittenSample<<m_nbWrittenBytes<<nbBytes;

        }


}

*/
